# Code that give estimates for the nested case-control data

# Read nested case-control data:
tb.ncc<-read.table("tb.ncc.txt",header=T)

library(survival)

# Fit model nested case-control data:
fit.ncc<-coxph(Surv(age.in,age.out,case)~log2(dose+1)+I(age.rx/10)+strata(setno), data=tb.ncc)
summary(fit.ncc)
