% cox regression

function beta=coxph(Y,Delta, X,  epsilon, maxiter, atrisk)

m=size(X,2); n=length(Y);
temp1=X'*Delta;

error=1; iter=0;
oldbeta=zeros(m,1);
while(error>epsilon & iter<maxiter)
     Ebeta=exp(X*oldbeta);
     denom=atrisk*Ebeta;
     score=temp1;
     dscore=zeros(m,m);
    % denom(denom==0)=1;
     for k=1:1:m
         tempk=(atrisk*(Ebeta.*X(:,k)))./denom;
         score(k)=score(k)-Delta'*tempk;
         for l=k:1:m
             templ=(atrisk*(Ebeta.*X(:,l)))./denom;
             tempkl=(atrisk*(Ebeta.*X(:,k).*X(:,l)))./denom;
             dscore(k,l)=dscore(k,l)-Delta'*tempkl+Delta'*(tempk.*templ);
             dscore(l,k)=dscore(k,l);
         end
     end
     newbeta=oldbeta-inv(dscore)*score;
     error=sum(abs(newbeta-oldbeta));
     iter=iter+1;
     [oldbeta,newbeta]
     oldbeta=newbeta;
     [iter, error]
  
end

beta=newbeta;
