function logf=loglikfun(oldPX_Z, oldlambda, oldcoef, Delta, ...
                        X, ZW, R, Xs,  n, m, KZZ, r0, atrisk)

                    % G'(x)=1/(1+rx), G(x)=log(1+rx)/r
oldbeta=oldcoef(1); oldgamma=oldcoef(2:end); 
oldLambda=atrisk'*(oldlambda);

temp=zeros(n,1);
for k=1:1:m
    EXZW=exp(ZW*oldgamma+Xs(k)*oldbeta);
    LambdaEXZ=oldLambda.*EXZW;
    if (r0>0)
       G=log(1+r0*LambdaEXZ)/r0;
    else
       G=LambdaEXZ;
    end
    dG=1./(1+r0*LambdaEXZ);
    PY_ZWX=exp(Delta*(Xs(k)*oldbeta)+Delta.*log(dG)-G);
    PXk_Z=oldPX_Z(k,KZZ)';
    PXk_Z(R==1,:)=(X(R==1)==Xs(k)).*PXk_Z(R==1);
    temp=temp+PY_ZWX.*PXk_Z;
end
logf=sum(log(oldlambda(Delta==1)))+Delta'*(ZW*oldgamma)+sum(log(temp));