function cov=covest(oldcoef, oldlambda, oldPX_Z, ...
                  Y, Delta, X, ZW, R, Xs, n, m, KZZ, hn, r0, atrisk)
              
ngamma=size(ZW,2);

maxloglik=loglikfun(oldPX_Z, oldlambda, oldcoef, Delta, ...
                        X, ZW, R, Xs, n, m, KZZ, r0, atrisk);
      
cov=zeros(ngamma+1, ngamma+1);
for k=1:(ngamma+1)
    for s=k:(ngamma+1)
        temppar1=oldcoef; temppar2=temppar1; 
        temppar1(k)=temppar1(k)+hn; temppar2(s)=temppar2(s)+hn;
        temppar3=temppar1; temppar3(s)=temppar3(s)+hn;
        
        loglik1=proflik(temppar1, oldlambda, oldPX_Z, ...
                  Y, Delta, X, ZW, R, Xs, n, m, KZZ, r0, atrisk);
        loglik2=proflik(temppar2, oldlambda, oldPX_Z, ...
                  Y, Delta, X, ZW, R, Xs, n, m, KZZ, r0, atrisk);
        loglik3=proflik(temppar3, oldlambda, oldPX_Z, ...
                  Y, Delta, X, ZW, R, Xs, n, m, KZZ, r0, atrisk);
             
        cov(k,s)=(loglik3-loglik1-loglik2+maxloglik)/hn^2;
        cov(s,k)=cov(k,s);
    end
end
cov=-inv(cov); 